#######################################################
#######################################################
############    COPYRIGHT - DATA SOCIETY   ############
#######################################################
#######################################################

##############################
##    WORKING WITH LISTS    ##
##############################

## NOTE: To run individual pieces of code 
## select the line of code and press ctrl + enter for Windows
## and command + enter for Macs

#==================================================================================

#### CREATING LISTS ####

# 1. Create a list with the elements TRUE, 27, "aa", "John" and label it list1

list1 = list(TRUE, 27, "aa", "John")
list1

# 2. Add the element FALSE to list1

list1[5] = FALSE
list1

# 3. Remove the first element, TRUE, from list1

list1[1] = NULL
list1


# 4. Replace the second element in list1 with the element "cc"

list1[2] = "cc"
list1

# 5. Name the elements in the list as A, B, D, E

names(list1) = c("A", "B", "D", "E")
list1

# 5. Create a list with the following elements and name it list2:
#    Dave, Erin, Natalie
#    Dobson, Ericsson, Wolfe
#    39, 31, 33
#    Accountant, Teacher, Engineer

list2 = list(c("Dave", "Erin", "Natalie"), c("Dobson", "Ericsson", "Wolfe"), c(39, 31, 33), 
              c("Accountant", "Teacher", "Engineer"))
list2

# 6. Name the elements in list2 as First.name, Last.name, Age, Job

names(list2) = c("First.name", "Last.name", "Age", "Job")
list2

# 7. Add an element to list2 called "Housing" with the data "Apt", "House", "Condo"

list2$Housing = c("Apt", "House", "Condo")
list2

# 8. In list2, replace the first number in "Age" with the number 37

list2[["Age"]][1] = 37
list2

# or

list2[[3]][1] = 37

# 9. Delete the "Condo" element in "Housing" in list2

list2[[5]][-3]
list2

# 10. Add "Townhouse" to the "Housing" element in list2

list2[[5]][3] = "Townhouse"
list2

# Here is information about five customers, items they purchased,
# quantity of items, and whether or not they're part of the
# store membership program
#
# Kallie, bananas, 5, TRUE
# Corey, oranges, 4, FALSE
# Abigail, apples, 10, FALSE
# Carl, lemons, 2, TRUE
# Mitch, grapefruit, 3, TRUE

# 11. Create a list that contains the following named categories:
#     "Names", "Items", "Quantity", and "Membership"

Customers = list("Names" = c("Kallie", "Corey", "Abigail", "Carl", "Mitch"), "Items" = c("bananas", "oranges",
                             "apples", "lemons", "grapefruit"), "Quantity" = c(5, 4, 10, 2, 3),
                 "Membership" = c(T, F, F, T, T))
Customers

# 12. Create a data frame from that list

as.data.frame(Customers)
View(Customers) 

# Here is more information about additional purchases that the customers made:
#
# Kallie, 5 bananas, 4 tomatoes, 3 cucumbers, TRUE
# Corey, 2 apples, 1 lemon, 4 oranges, FALSE
# Abigail, 5 tomatoes, 3 limes, 10 apples, FALSE
# Carl, 2 lemons, 6 avocadoes, 8 tomatoes, TRUE
# Mitch, 5 tomatoes, 3 grapefruit, 2 cucumbers, TRUE

# 13. Create a list for each customer. Label the list as the customer name, and name the
#     elements as "Items", "Quantity", and "Membership"

Kallie = list("Items" = c("bananas", "tomatoes", "cucumbers"), "Quantity" = c(5, 4, 3), "Membership" = T)
Corey = list("Items" = c("apples", "lemons", "oranges"), "Quantity" = c(2, 1, 4), "Membership" = F)
Abigail = list("Items" = c("tomatoes", "grapefruit", "apples"), "Quantity" = c(5, 3, 10), "Membership" = F)
Carl = list("Items" = c("lemons", "avocados", "tomatoes"), "Quantity" = c(2, 6, 8), "Membership" = T)
Mitch = list("Items" = c("bananas", "grapefruit", "cucumbers"), "Quantity" = c(5, 3, 2), "Membership" = T)

# 14. Once these lists are created, use the cbind function to arrange each list by column and assign
#     them to a variable.
#     Hint: The first element in each should be the name of the customer

K2 = cbind("Kallie", Kallie$Items, Kallie$Quantity, Kallie$Membership)
View(K2)
C2 = cbind("Corey", Corey$Items, Corey$Quantity, Corey$Membership)
View(C2)
A2 = cbind("Abigail", Abigail$Items, Abigail$Quantity, Abigail$Membership)
View(A2)
Ca2 = cbind("Carl", Carl$Items, Carl$Quantity, Carl$Membership)
View(Ca2)
M2 = cbind("Mitch", Mitch$Items, Mitch$Quantity, Mitch$Membership)
View(M2)

# 15. Next, use the rbind function to combine all of these into a variable called Customer.purchases

Customer.purchases = rbind(K2, C2, A2, Ca2, M2)
View(Customer.purchases)

# 16. Rename the columns to match the categories from the lists

colnames(Customer.purchases) = c("Name", "Item", "Quantity", "Membership")
View(Customer.purchases)



# Continue to practice these operations until you feel
# comfortable in R. The only way to become truly
# proficient is to spend time coding!